/// BulletML Υѡĥ꡼ by yggdrasil
/**
 * Yggdrasil ˤ BulletML Υѡ
 */

#ifndef BULLETMLPARSER_YGG_H_
#define BULLETMLPARSER_YGG_H_

#include <string>

#include "ygg/ygg.h"

class BulletMLParserYggdrasil : public BulletMLParser {
public:
    explicit BulletMLParserYggdrasil(const std::string& filename);
    virtual ~BulletMLParserYggdrasil();

    virtual void parse();

protected:
    void getTree(yggdrasil::ygg_node);
    void translateNode(yggdrasil::ygg_node);

	std::string trimString(const std::string& str);

private:
    std::string xmlFile_;
    class BulletMLNode* curNode_;
};

#endif // ! BULLETMLPARSER_YGG_H_
