/// Ūʥĥ꡼

#ifndef TREE_H_
#define TREE_H_

#include <list>

/// ĥ꡼Υ饹
/**
 * ĥ꡼äƤΤϥƥʤ¸ߤʤΤǤȻפ
 * ǡΡɤäƤ°ӤӤ饹ν礬ƥʤǤȡ
 * ǥ󥿡եϡ
 * class YourNode : public TreeNode<YourNode>;
 * äƶ礤
 * ݥ󥿴ȤƤ롣
 * 󥹥󥹤δʤϤʤɡ
 * setReleaseDuty ƤФ줿Ρɤ˲ȡ
 * ©Ұʲ˲롣
 */
template <class C_>
class TreeNode {
public:
    // ƥץ졼ȰǺ߷פˤΤ
    typedef std::list<C_*> Children;
    typedef typename Children::iterator ChildIterator;
    typedef typename Children::const_iterator ConstChildIterator;

public:
    TreeNode() {
		releaseDuty_ = false;
    }
    virtual ~TreeNode();

    void addChild(C_* c) {
		c->setParent(dynamic_cast<C_*>(this));
		children_.push_back(c);
    }
    void setReleaseDuty(bool bl) {
		releaseDuty_ = bl;
    }
    void setParent(C_* c) {
		parent_ = c;
    }

    ChildIterator childBegin() { return children_.begin(); }
    ChildIterator childEnd() { return children_.end(); }
	size_t childSize() { return children_.size(); }
    ConstChildIterator childBegin() const { return children_.begin(); }
    ConstChildIterator childEnd() const { return children_.end(); }
    C_* getParent() { return parent_; }

private:
    Children children_;
    C_* parent_;
    bool releaseDuty_;
};

template <class C_>
TreeNode<C_>::~TreeNode() {
    if (releaseDuty_) {
		ChildIterator ite;
		for (ite = children_.begin(); ite != children_.end(); ite++) {
			(*ite)->setReleaseDuty(true);
			delete *ite;
		}
    }
}

#endif // ! TREE_H_
